
local function lerp (var1, var2, t) do
	var1 = FixedMul($1*FRACUNIT, FRACUNIT-t)
	var2 = FixedMul($1*FRACUNIT, t)
	local r = var1+var2
	r = $1/FRACUNIT
	return r
	end
end

local function lerp2(var1, var2, t) do
	local r = lerp(lerp(var1, var2, t), var2, t)
	return r
	end

end
freeslot(
"sfx_jettrk",
"sfx_jetjmp",
"sfx_jetdrf",
"sfx_jetbst"
)
sfxinfo[sfx_jetdrf] = {
        singular = false,
        priority = 64,
        flags = SF_TOTALLYSINGLE
}

addHook("PlayerSpawn", function(player)
		if player.mo.skin ~= "jet" or player.spectator then
			return
		end
			player.riding = 0
			player.driftangle = 0
			player.drifting = 0
			player.boostspeed = 0
			player.boosttime = 0
			player.lastxangle = 0
			player.air = 100
			player.airtic = 0
			player.tricktime = 0
			player.trick = 0
			player.jumpdown = false
			player.spindown = false
			player.c1down = false
			player.movedown = false
			player.gearlocked = false
			player.gearonground = false
			player.airgain = 0
			player.airloss = 0
			player.trickcount = 0
			player.trickrank = 0
			player.trickranktime = 60
		
end)

addHook("PreThinkFrame", function()
	for player in players.iterate do
		if player.mo.skin ~= "jet" then
			continue
		end
		
		
	if player.riding == nil then
			player.riding = 0
			player.driftangle = 0
			player.drifting = 0
			player.boostspeed = 0
			player.boosttime = 0
			player.lastxangle = 0
			player.air = 100
			player.airtic = 0
			player.tricktime = 0
			player.trick = 0
			player.jumpdown = false
			player.spindown = false
			player.c1down = false
			player.movedown = false
			player.gearlocked = false
			player.gearonground = false
			player.airgain = 0
			player.airloss = 0
			player.trickcount = 0
			player.trickrank = 0
			player.trickranktime =60
	end
	
	
	if (P_IsObjectOnGround(player.mo) or player.pflags & PF_JUMPED) and
	((player.air+player.airgain <= 0) or (player.gearlocked) or (player.mo.eflags & MFE_VERTICALFLIP) or  (player.powers[pw_carry] & CR_ROLLOUT) ) then
			if( player.speed > 18*FRACUNIT ) then
				local trueangle = R_PointToAngle2(0,0,player.mo.momx,player.mo.momy)
				player.mo.momy = $1-FixedMul(player.speed-(18*FRACUNIT), sin(trueangle) )
				player.mo.momx = $1-FixedMul(player.speed-(18*FRACUNIT), cos(trueangle) )
			end
			if (player.mo.state == S_PLAY_RUN or player.mo.state == S_PLAY_JET_RIDE1) then
				player.mo.state = S_PLAY_WALK
			end
			
	end
				//Hey Jet! Do a Trick!
	 if (player.trick != 0 and player.riding > 0) then
		player.cmd.sidemove = 0
		player.cmd.forwardmove = 0
	 end
	if (player.riding >0) and (player.gearonground == false) 
		and ( (player.cmd.sidemove != 0) or (player.cmd.forwardmove != 0) )  
		and (player.trick == 0) 
	//and (player.jumpdown == false) 
		and (player.movedown == false) then
		
				S_StartSound(player.mo,sfx_jettrk)
				player.driftangle = player.mo.angle
				if player.cmd.forwardmove > 0	then
					player.trick = 1
					player.tricktime = 24
					player.mo.state = S_PLAY_JET_FLIP
					player.mo.momy = $1+FixedMul(5*FRACUNIT, sin(player.driftangle) )
					player.mo.momx = $1+FixedMul(5*FRACUNIT, cos(player.driftangle) )
				elseif player.cmd.sidemove < 0	then
					player.trick = 3
					player.tricktime = 24
					player.mo.state = S_PLAY_JET_JESSY
					
					player.mo.momy = $1+FixedMul(5*FRACUNIT, sin(player.driftangle + ANGLE_90) )
					player.mo.momx = $1+FixedMul(5*FRACUNIT, cos(player.driftangle + ANGLE_90) )
				elseif player.cmd.sidemove > 0	then
					player.trick = 4
					player.tricktime = 24
					player.mo.state = S_PLAY_JET_JESSY
					player.mo.momy = $1+FixedMul(5*FRACUNIT, sin(player.driftangle - ANGLE_90) )
					player.mo.momx = $1+FixedMul(5*FRACUNIT, cos(player.driftangle - ANGLE_90) )
				else
					player.trick = 2
					player.tricktime = 24
					player.mo.state = S_PLAY_JET_FLIP
					player.mo.momz = $1+(4*FRACUNIT)
				end
		
		end
		
		end
end)

addHook("ThinkFrame", function()
	for player in players.iterate do
		if player.mo.skin ~= "jet" then
			continue
		end
	
	//if  (player.mo.state == S_PLAY_RUN or player.mo.state == S_PLAY_SPRING or player.mo.state == S_PLAY_JET_RIDE1 or player.mo.state == S_PLAY_JET_DRIFT or player.mo.state == S_PLAY_JET_JESSY or player.mo.state == S_PLAY_JET_FLIP) 
	if  (player.mo.state == S_PLAY_RUN) 
	and player.air+player.airgain > 0 
	and not (player.gearlocked) 
	and not (player.mo.eflags & MFE_VERTICALFLIP)
	and not (player.powers[pw_carry] & CR_ROLLOUT) 
	then
		player.riding = 1
	elseif (player.riding > 0) and
		(player.mo.state == S_PLAY_PAIN or 
		player.mo.state == S_PLAY_DEAD or 
		player.mo.state == S_PLAY_GASP or 
		player.mo.state == S_PLAY_RIDE or 
		player.gearlocked
		or (player.mo.eflags & MFE_VERTICALFLIP)
		or  (player.powers[pw_carry] & CR_ROLLOUT) ) then
		player.riding = 0
		player.boostspeed = 0
		player.drifting = 0
	end
	
	
	//Air meter recovery during idle frames
	if  (player.mo.state == S_PLAY_WAIT) then
		player.mo.state = S_PLAY_JET_PUMP
		player.driftangle = player.drawangle
	end
	if  (player.mo.state == S_PLAY_JET_PUMP) then
		player.airtic = $1+1
		player.mo.momx = 0
		player.mo.momy = 0
		player.drawangle = player.driftangle
		if (player.airtic > 0) then
			if (player.airtic+player.air <= 100) then
				player.airgain = player.airtic
			else
				player.airgain = 100-player.air
			end
			player.mo.frame = player.airtic / 3
		else
			player.mo.frame = 0
		end
		if (player.airtic > 10) then
			player.air = $1+player.airgain
			player.airtic = -20
			player.airgain = 0
			if (player.air > 100) then
				player.air = 100
			end
						for rover in player.mo.subsector.sector.ffloors() 
				if rover.flags & FF_BUSTUP and rover.flags & FF_EXISTS then
					if (rover.bottomheight < player.mo.z+(player.mo.height*2)) and (rover.topheight > player.mo.z-(player.mo.height*2)) then
						EV_CrumbleChain(rover)
					end
				end
			end
			
		end
		
		if ( (player.cmd.sidemove != 0) or (player.cmd.forwardmove != 0) )  then
			player.mo.state = S_PLAY_WALK
			player.airtic = 0
		end
	end
	
	//Air meter effect ticcing down
	
		if (player.airloss > 0) then
			player.airloss = ($1*19)/20
		end
	
	if player.riding then
	
		if player.drifting == 0 and player.trick == 0 then
			player.mo.state = S_PLAY_JET_RIDE1
		end
		
		player.airtic = $1+1
		
		if (player.airtic >= 12) then
			player.air = $1-1
			player.airtic = 0
		end
		
		if (player.air+player.airgain <= 0) then
			player.riding = 0
		end
		
		//Using a tracer object to sample the floor position
		local xtremetracer = P_SpawnMobj(player.mo.x,player.mo.y,player.mo.floorz+1,MT_XTREMETRACER)
		P_TryMove(xtremetracer, player.mo.x, player.mo.y, player.mo.floorz)

		local targethoverheight = player.mo.floorz+(16*FRACUNIT)
		
		if player.mo.z <= targethoverheight+(8*FRACUNIT) and player.jumpdown == false then //On 'ground' behavior
		
		
			if xtremetracer.standingslope ~= nil then
				local slopesample1 = P_GetZAt(xtremetracer.standingslope, player.mo.x, player.mo.y)
				local slopesample2 = P_GetZAt(xtremetracer.standingslope,  player.mo.x+player.mo.momx, player.mo.y+player.mo.momy)
				player.xangle = R_PointToAngle2(0,slopesample1,player.speed,slopesample2)
			else
					player.xangle = 0
			end
			if (player.xangle >= player.lastxangle and player.mo.z < targethoverheight) then
				player.mo.momx = FixedMul( player.mo.momx,
				cos(player.xangle) )
				player.mo.momy = FixedMul( player.mo.momy,
				cos(player.xangle) )
				player.mo.momz =  FixedMul(sin(player.xangle), player.speed) 
				player.mo.momz =  $1+((targethoverheight-player.mo.z)/10)
				if (player.mo.pmomz > 0) then 
					player.mo.momz =  $1+ player.mo.pmomz
				end
			end
			player.lastxangle = player.xangle
			
			
			if (player.cmd.buttons & BT_JUMP) and not (player.jumpdown)
				//player.pflags = $1|PF_JUMPED
				player.mo.momz = $1+((75*FRACUNIT)/10)
				player.mo.z = targethoverheight+1
				S_StartSound(player.mo,sfx_jetjmp)
				
			end
		end
		if (player.mo.z < targethoverheight)
			player.gearonground = true
		
		else
		
			player.gearonground = false
		end
		
		if (player.gearonground or P_IsObjectOnGround(player.mo) ) then
		
			//Cash in our air gain from doing tricks, applying a penalty for botching the landing as necessary.
			if (player.airgain > 0) then
				if (player.trick > 0) then 
					player.trickcount = 0
					player.trick = 0
					player.tricktime = 0
					player.airgain = $1/3
					player.mo.state = S_PLAY_JET_RIDE1
				end
				
				player.trickrank = player.trickcount*10
					if (player.trickrank > 30) then
						if (P_RandomRange(1, 10) == 5) then
							player.trickrank = 40
						else
							player.trickrank = 30
						end
					end
				if (player.trickrank > 0) then
					player.trickrank = $1+P_RandomRange(0, 3)
				end
				player.trickranktime = 0
				player.trickcount = 0
				player.air = $1 + player.airgain
				player.airgain = 0
			end
		end
		
		if (player.trick > 0) then
			player.tricktime = $1-1
			if (player.trick == 1)
				player.mo.state = S_PLAY_JET_FLIP
				player.drawangle = player.driftangle
				player.mo.frame = (24-player.tricktime)/3
				
					local randangle = (24-player.tricktime*ANG15)+(P_RandomRange( -20, 20)*ANG1)-ANGLE_90
					local smoke = P_SpawnMobj(
						player.mo.x + FixedMul(50*sin(randangle), cos(player.drawangle) ),
						player.mo.y + FixedMul(50*sin(randangle), sin(player.drawangle) ),
						player.mo.z + 50*cos(randangle),
						MT_TURBULENCE)
					smoke.scale = P_RandomFixed()*5
				
			elseif (player.trick == 2)
				player.mo.state = S_PLAY_JET_FLIP
				player.drawangle = player.driftangle
				player.mo.frame = player.tricktime/3
				
					local randangle = (player.tricktime*ANG15)+(P_RandomRange( -20, 20)*ANG1)-ANGLE_90
					local smoke = P_SpawnMobj(
						player.mo.x + FixedMul(50*sin(randangle), cos(player.drawangle) ),
						player.mo.y + FixedMul(50*sin(randangle), sin(player.drawangle) ),
						player.mo.z + 50*cos(randangle),
						MT_TURBULENCE)
					smoke.scale = P_RandomFixed()*5
				
			elseif (player.trick == 3) then
				player.mo.state = S_PLAY_JET_JESSY
				player.mo.frame = player.tricktime/3		
				
					
					local randangle = (24-player.tricktime*ANG15)+(P_RandomRange( -20, 20)*ANG1)-ANGLE_90
					local smoke = P_SpawnMobj(
						player.mo.x + (50* cos(randangle) ),
						player.mo.y + (50* sin(randangle) ),
						player.mo.z,
						MT_TURBULENCE)
					smoke.scale = P_RandomFixed()*5
					
			elseif (player.trick == 4) then
				player.mo.state = S_PLAY_JET_JESSY
				player.mo.frame = (24-player.tricktime)/3
				
				
					local randangle = (player.tricktime*ANG15)+(P_RandomRange( -20, 20)*ANG1)-ANGLE_90
					local smoke = P_SpawnMobj(
						player.mo.x + (50* cos(randangle) ),
						player.mo.y + (50* sin(randangle) ),
						player.mo.z,
						MT_TURBULENCE)
					smoke.scale = P_RandomFixed()*5
					
			end	
			
			if (player.tricktime % 2 == 0 and (player.airgain + player.air < 100) and player.trick < 3) then
				player.airgain = $1+1
			end
			if (player.tricktime % 3 > 0 and (player.airgain + player.air < 100) and player.trick >= 3) then
				player.airgain = $1+1
			end
			if (player.tricktime == 0) then
			
				player.mo.state = S_PLAY_JET_RIDE1
				player.trickcount = $1+1
				player.trick = 0
			end
		end
						//Drift controls
			if (player.cmd.buttons & BT_USE) then
					
				if (player.drifting == 1) then
					player.driftangle = player.mo.angle
				end
				if (player.drifting == 4) then
					player.boostspeed = player.speed
				end
				if (player.drifting > 5) then
					if (player.drifting %  6 == 5) then
						S_StartSound(player.mo,sfx_jetdrf)
					end
					local randangle = player.driftangle+(P_RandomRange( -45, 45)*ANG1)
					local smoke = P_SpawnMobj(player.mo.x+(50*cos(randangle)),player.mo.y+(50*sin(randangle)),player.mo.z,MT_TURBULENCE)
					smoke.scale = P_RandomFixed()*5
					player.mo.state = S_PLAY_JET_DRIFT
					player.mo.momy = FixedMul((player.boostspeed*7)/10, sin(player.driftangle) )
					player.mo.momx = FixedMul((player.boostspeed*7)/10, cos(player.driftangle) )
					local angledist = (AngleFixed(player.driftangle)/FRACUNIT)-(AngleFixed(player.mo.angle)/FRACUNIT)
					angledist = (($1)/36)+2
					angledist = ($1+10)%10
					if (angledist < 0) then
						angledist = 0
					elseif (angledist > 6) then
						angledist = 0
					elseif (angledist > 4) then
						angledist = 4
					end
					player.mo.frame = angledist
				end
				player.drifting = $1+1
				player.drawangle = player.driftangle
				
			elseif (player.drifting > 0)
			
				if (player.drifting > 5) then //If you've been holding the button, we're coming out of a drift
					player.mo.state = S_PLAY_JET_RIDE1
					player.drawangle = player.mo.angle
					player.mo.momy = FixedMul(player.boostspeed, sin(player.mo.angle))
					player.mo.momx = FixedMul(player.boostspeed, cos(player.mo.angle))
					player.boosttime = 30
					S_StartSound(player.mo,sfx_jetbst)
					
				elseif (player.air > 10)  then//If you just tapped it, we do a boost instead, which costs air.
					S_StartSound(player.mo,sfx_jetbst)
					local boostspeed = 0
					if player.speed > 20*FRACUNIT then
						boostspeed = player.speed+(20*FRACUNIT)
					else
						
						boostspeed = (40*FRACUNIT)
					end
					player.mo.momy = FixedMul(boostspeed, sin(player.mo.angle))
					player.mo.momx = FixedMul(boostspeed, cos(player.mo.angle))
					player.airloss = 10
					player.air = $1-10
					player.boosttime = 30
				end
				player.drifting = 0
			
			end
		if (player.mo.state == S_PLAY_JET_RIDE1) then
			local cxangle = AngleFixed(R_PointToAngle2(0,0,player.speed,player.mo.momz))/FRACUNIT
			cxangle = ($1+90)%360
			
			cxangle = (($1*100)/1928)-1
			if cxangle < 0 then
				cxangle = 0
			elseif cxangle > 6 then
				cxangle = 6
			end
			
			player.mo.frame = cxangle
		end
			
			
		end
		
		
	if (player.air < 0 ) then
		player.air = 0 //Juuuust in case
	end
	if (player.cmd.buttons & BT_JUMP) then
		player.jumpdown = true
	else 
		player.jumpdown = false
	end
	if (player.cmd.buttons & BT_USE) then
		player.spindown = true
	else 
		player.spindown = false
	end
	
	if  ( (player.cmd.sidemove != 0) or (player.cmd.forwardmove != 0) ) then
		player.movedown = true
	else
		player.movedown = false
	end
	
	if (player.trickranktime < 60) then
		player.trickranktime = $1+1
	end
	if (player.cmd.buttons & BT_CUSTOM1) then
		if (player.c1down == false) then
			if (player.gearlocked) then
				player.gearlocked = false
			else
				player.gearlocked = true
				player.trick = 0
				player.boosttime = 0
				player.drifting = 0
				if (player.mo.state == S_PLAY_JET_RIDE1) then
					player.mo.state = S_PLAY_FALL
				end
			end
			player.c1down = true
		end
	else 
		player.c1down = false
	end
	
	if (player.boosttime > 0) then
		player.boosttime = $1-1
		P_SpawnGhostMobj(player.mo)
	end
	
	
	end
end)
local hudinit = false
local airmeterb
local airmeterc
local airmeterd
local airmeter1
local airmeter2
local airmeter3
local trickrank = {}
local blinktime
hud.add(function(v, player, camera) 
		if player.mo.skin ~= "jet" then
			return
		end
	if (hudinit == false) then
		airmeterb = v.cachePatch("AIRMETB")
		airmeterc = v.cachePatch("AIRMETC")
		airmeterd = v.cachePatch("AIRMETD")
		airmeter1 = v.cachePatch("AIRMET1")
		airmeter2 = v.cachePatch("AIRMET2")
		airmeter3 = v.cachePatch("AIRMET3")
		trickrank[0] = v.cachePatch("XRANKE0")
		
		trickrank[10] = v.cachePatch("XRANKB1")
		trickrank[11] = v.cachePatch("XRANKB2")
		trickrank[12] = v.cachePatch("XRANKB3")
		trickrank[13] = v.cachePatch("XRANKB4")
		
		trickrank[20] = v.cachePatch("XRANKA1")
		trickrank[21] = v.cachePatch("XRANKA2")
		trickrank[22] = v.cachePatch("XRANKA3")
		trickrank[23] = v.cachePatch("XRANKA4")
		
		trickrank[30] = v.cachePatch("XRANKS1")
		trickrank[31] = v.cachePatch("XRANKS2")
		trickrank[32] = v.cachePatch("XRANKS3")
		trickrank[33] = v.cachePatch("XRANKS4")
		
		trickrank[40] = v.cachePatch("XRANKX1")
		trickrank[41] = v.cachePatch("XRANKX2")
		trickrank[42] = v.cachePatch("XRANKX3")
		trickrank[43] = v.cachePatch("XRANKX4")
		hudinit = true
		blinktime = 0
	end
	if (player.airgain == nil)  then
		return
	end
	if (player.trickranktime < 10) then
		v.draw(224,
		lerp2(0,150, ( (player.trickranktime) * FRACUNIT) /10)  , 
		trickrank[player.trickrank])
	elseif (player.trickranktime < 20) then
		v.draw(224,150 ,trickrank[player.trickrank])
		
		v.drawScaled(224*FRACUNIT, 150*FRACUNIT, 
		lerp2(1000, 150,10-( (player.trickranktime-10) * FRACUNIT) /10)*FRACUNIT/100
		,trickrank[player.trickrank],
		V_90TRANS)
	elseif (player.trickranktime < 50) then
		v.draw(224,150 ,trickrank[player.trickrank])
	elseif (player.trickranktime < 60) then
		v.draw(224,
		lerp2(150,220, ( (player.trickranktime-50) * FRACUNIT) /10)  , 
		trickrank[player.trickrank])
	end
	
	if (player.airgain > 0) then
		v.drawStretched(FRACUNIT*320, FRACUNIT*174, FRACUNIT, (player.air+player.airgain)*FRACUNIT, airmeter2)
		v.drawStretched(FRACUNIT*320, FRACUNIT*174, FRACUNIT, (player.air+(player.airgain/3))*FRACUNIT, airmeter3,V_80TRANS)
	end
	if (player.airloss > 0) then
		v.drawStretched(FRACUNIT*320, FRACUNIT*174, FRACUNIT, (player.air+player.airloss)*FRACUNIT, airmeter2)
	end
	v.drawStretched(FRACUNIT*320, FRACUNIT*174, FRACUNIT, player.air*FRACUNIT, airmeter1)
	v.draw(320, 100, airmeterb, 0, v.getColormap(0,player.mo.color))
	
	if (player.gearlocked) then
		v.draw(320, 100, airmeterc, 0, v.getColormap(0,player.mo.color))
	elseif (player.mo.eflags & MFE_VERTICALFLIP) then
		blinktime = ($1+1)%30
		if (blinktime < 15) then
			v.draw(320, 100, airmeterd, 0)
		else
			v.draw(320, 100, airmeterd, V_80TRANS)
		end
	end
	
	
end, "game")

addHook("SpinSpecial", function(player)
	if player.mo.skin ~= "jet" then 
		return nil
	end
	if (player.riding == 0 and P_IsObjectOnGround(player.mo) and player.speed == 0) then
		if (player.mo.state ~= S_PLAY_JET_PUMP) then
			player.mo.state = S_PLAY_JET_PUMP
			player.driftangle = player.drawangle
		elseif (player.airtic < 1 and player.spindown == false) then
			player.airtic = 1
		end
	end
return true
end)


addHook("ShouldDamage", function(p, inflictor, source, damage, damagetype)
	if p.skin ~= "jet" then 
		return nil
	end
	if not (inflictor) or not (source) then
		return nil
	end
	if (inflictor ~= source) then
		return nil
	end
	if (p.player.boosttime > 0) or ( p.player.trick > 0) or (p.player.drifting > 0) then
		P_DamageMobj(inflictor, p, p, 1)
		return false
	end
		return nil
	
	
	
end, MT_PLAYER)


addHook("MobjMoveCollide", function(player,thing)
	if player.skin ~= "jet" then 
		return nil
	end
	if (thing.flags & MF_MONITOR and player.player.riding > 0 and (thing.z < player.z+player.height and thing.z > player.z-player.height) )then
		P_DamageMobj(thing, player, player)
	end
	
end, MT_PLAYER)